//file: invariants.hpp  Version 1.02  Jan 8, 2004
#ifndef INVARIANTS_HPP
#define INVARIANTS_HPP

// Copyright Daniel Watkins 2004. Use, modification and distribution
//    is subject to the Boost Software License, Version 1.0.
//         <http://www.boost.org/LICENSE_1_0.txt>
// See "invariants.txt" for preliminary documentation.

#ifdef __DMC__
# define BOOST_USE_INT_3_INSTEAD_OF_ASSERT
#endif

#ifdef BOOST_USE_INT_3_INSTEAD_OF_ASSERT
# ifdef _DEBUG
#  ifdef assert
#   undef assert
#  endif
#  define assert(x) do{if(!((x)))asm int 3;}while(0)
# else
#  define assert(x) do{(void)(0);}while(0)
# endif
#else
# include <cassert>
#endif

namespace boost { namespace DBC {

//EEICHK == "Entry/Exit Invariants CHecK"
template< typename T >
class EEICHK
{
    friend class T;
    EEICHK( T const & t )
    : t_( t )
    {
        t_.CHECK_INVARIANTS();
    }
    ~EEICHK()
    {
        t_.CHECK_INVARIANTS();
    }
    T const & t_;
    EEICHK(); //no default; needs the ref.
    EEICHK( EEICHK const & );
    void operator=( EEICHK const & );
};
                }               }

#ifdef _DEBUG

#define INVARIANTS( name )    \
typedef name THIS_TYPE_NAME;  \
friend struct EEICHK< name >; \
void CHECK_INVARIANTS() const \
/**/
#define INV_CHECK()        \
EEICHK< THIS_TYPE_NAME >   \
EECK_(*this); do{}while(0) \
/**/

#else //Release mode:

#define INVARIANTS( name) \
template<int DummY>       \
void dUMMy() const        \
/**/
#define _INVARIANTS_CHECKED_ \
/**/

#endif

#endif

